Skip to main content

Styling

You can customize styles of the Grid interface to meet your project requirements. The library provides two built-in themes:

  • Willow
  • WillowDark

Themes ensure that all components render correctly. The grid package also ships two CSS files you should import to add styles:

  • all.css: grid plus styles for sub-components like menus and toolbars
  • style.css: grid only. Use this when you import sub-component styles separately

Moreover, you can apply custom styles to cells, columns and rows using the cellStyle, columnStyle, and rowStyle properties.

Theme settings​

Willow theme settings:

:global(.wx-willow-theme) {
--wx-table-select-background: #eaedf5;
--wx-table-select-focus-background: #ebedf3;
--wx-table-select-color: var(--wx-color-font);
--wx-table-border: 1px solid #e6e6e6;
--wx-table-select-border: inset 3px 0 var(--wx-color-primary);
--wx-table-header-border: var(--wx-table-border);
--wx-table-header-cell-border: var(--wx-table-border);
--wx-table-footer-cell-border: var(--wx-table-border);
--wx-table-cell-border: var(--wx-table-border);
--wx-header-font-weight: 600;
--wx-table-header-background: #f2f3f7;
--wx-table-fixed-column-right-border: 3px solid #e6e6e6;
--wx-table-editor-dropdown-border: var(--wx-table-border);
--wx-table-editor-dropdown-shadow: 0px 4px 20px 0px rgba(44, 47, 60, 0.12);
}

:global(.wx-willow-theme .menu) {
box-shadow: 0px 4px 20px 0px rgba(44, 47, 60, 0.12);
outline: 1px solid #e6e6e6;
}

WillowDark theme settings:

:global(.wx-willow-dark-theme) {
--wx-table-select-background: #384047;
--wx-table-select-focus-background: #465059;
--wx-table-select-color: var(--wx-color-font);
--wx-table-border: var(--wx-border);
--wx-table-select-border: inset 3px 0 var(--wx-color-primary);
--wx-table-header-border: var(--wx-table-border);
--wx-table-header-cell-border: var(--wx-table-border);
--wx-table-footer-cell-border: var(--wx-table-border);
--wx-table-cell-border: var(--wx-table-border);
--wx-header-font-weight: 600;
--wx-table-header-background: #20262b;
--wx-table-fixed-column-right-border: 3px solid var(--wx-background-alt);
--wx-table-editor-dropdown-border: var(--wx-border);
--wx-table-editor-dropdown-shadow: 0px 4px 16px 0px rgba(0, 0, 0, 0.6);
}
:global(.wx-willow-dark-theme .menu) {
box-shadow: 0px 4px 16px 0px rgba(0, 0, 0, 0.6);
outline: var(--wx-border);
}

Applying a theme​

You can style the interface applying one of the two themes:

  • Willow
  • WillowDark

Apply the desired theme by importing the theme from the source file and wrapping Grid into the required theme tag:

<script setup>
import { Grid, Willow } from "@svar-ui/vue-grid";
</script>

<template>
<Willow>
<Grid />
</Willow>
</template>

Customizing theme settings​

To change the table styles, create a CSS class by changing values of the required CSS variables and apply it to the Grid.

The example below will change any current theme applied to the table.

Example:

<script setup>
import { getData } from "./common/data";
import { Grid } from "@svar-ui/vue-grid";
import "@svar-ui/vue-grid/all.css";

const { data, columns } = getData();
</script>

<template>
<div class="demo" style="padding: 20px;">
<div>
<Grid :data="data" :columns="columns" :footer="true" />
</div>
</div>
</template>

<style scoped>
.demo {
--wx-table-header-background: #2ca0e3;
--wx-border: 1px solid #818080;
--wx-table-header-cell-border: #2ca0e3;
}
</style>

The example below demonstrates how to change the Willow theme that is applied to the table:

<script setup>
import { getData } from "./common/data";
import { Grid, Willow } from "@svar-ui/vue-grid";
import "@svar-ui/vue-grid/all.css";

const { data, columns } = getData();
</script>

<template>
<Willow>
<Grid :data="data" :columns="columns" :footer="true" />
</Willow>
</template>

<style scoped>
:global(.wx-willow-theme) {
--wx-table-header-background: #2ca0e3;
--wx-border: 1px solid #818080;
--wx-table-header-cell-border: #2ca0e3;
}
</style>

Disabling fonts​

Whenever you need to disable the fonts used in a theme, you can make use of the fonts property of the theme and set it to the false value:

<script setup>
import { getData } from "./common/data";
import { Grid, Willow } from "@svar-ui/vue-grid";
import "@svar-ui/vue-grid/all.css";

</script>

<template>
<div style="width:300px">
<Willow :fonts="false">
<Grid />
</Willow>
</div>
</template>
Pay attention

Please note that if you switch the default fonts off, you will have to include the fonts you need by yourself.

Styling cells​

The widget allows applying a custom Vue component to a cell and styling a cell with a custom CSS class.

info

This section describes how to apply styles to cells. If you want to know how apply custom components to cells, see the Applying custom components section.

To add a CSS class to a cell, use the cellStyle property. cellStyle can be defined as a function that returns the name of a CSS class or an empty string.

Example:

<script setup>
import { getData } from "./common/data";
import { Grid } from "@svar-ui/vue-grid";

const { data, columns } = getData();
</script>

<template>
<Grid
:data="data"
:columns="columns"
:cellStyle="(row, col) => (row.id == 14 && col.id == 'lastName' ? 'cellStyle' : '')"
:footer="true" />
</template>

<style scoped>
:global(.row:not(.selected) .cellStyle) {
color: white;
background: #1b85dc;
}
</style>

Styling columns​

To add a CSS class to a column, define the columnStyle property. columnStyle can be a function that returns the name of a CSS class or an empty string.

Example:

<script setup>
import { getData } from "./common/data";
import { Grid } from "@svar-ui/vue-grid";

const { data, columns } = getData();
</script>

<template>
<div style="padding: 20px;">
<div>
<Grid
:data="data"
:columns="columns"
:columnStyle="col => (col.id == 'city' ? 'columnStyle' : '')"
:footer="true" />
</div>
</div>
</template>

<style scoped>
:global(.columnStyle) {
text-decoration: underline;
color: rgb(231, 7, 231);
}
</style>

Styling rows​

To add a css class to a row, define the rowStyle property. The property can be a function that returns the name of a CSS class or an empty string.

Example:

<script setup>
import { getData } from "./common/data";
import { Grid } from "@svar-ui/vue-grid";

const { data, columns } = getData();
</script>

<template>
<Grid
:data="data"
:columns="columns"
:rowStyle="row => (row.id == 11 ? 'rowStyle' : '')"
:footer="true" />
</template>

<style scoped>
:global(.rowStyle:not(.selected) .cell) {
color: white;
background: #0ebf6c;
}
</style>

Related sample: Styling

Related articles:

Skip to main content

Styling

You can customize styles of the Grid interface to meet your project requirements. The library provides two built-in themes:

  • Willow
  • WillowDark

The gantt package also ships two CSS files you should import to add styles:

  • all.css: grid plus styles for sub-components like menus and toolbars
  • style.css: grid only. Use this when you import sub-component styles separately

Moreover, you can apply custom styles to cells, columns and rows using the cellStyle, columnStyle, and rowStyle properties.

Theme settings​

Willow theme settings:

.wx-willow-theme {
--wx-table-select-background: #eaedf5;
--wx-table-select-focus-background: #ebedf3;
--wx-table-select-color: var(--wx-color-font);
--wx-table-border: 1px solid #e6e6e6;
--wx-table-select-border: inset 3px 0 var(--wx-color-primary);
--wx-table-header-border: var(--wx-table-border);
--wx-table-header-cell-border: var(--wx-table-border);
--wx-table-footer-cell-border: var(--wx-table-border);
--wx-table-cell-border: var(--wx-table-border);
--wx-header-font-weight: 600;
--wx-table-header-background: #f2f3f7;
--wx-table-fixed-column-right-border: 3px solid #e6e6e6;
--wx-table-editor-dropdown-border: var(--wx-table-border);
--wx-table-editor-dropdown-shadow: 0px 4px 20px 0px rgba(44, 47, 60, 0.12);
}

.wx-willow-theme .menu {
box-shadow: 0px 4px 20px 0px rgba(44, 47, 60, 0.12);
outline: 1px solid #e6e6e6;
}

WillowDark theme settings:

.wx-willow-dark-theme {
--wx-table-select-background: #384047;
--wx-table-select-focus-background: #465059;
--wx-table-select-color: var(--wx-color-font);
--wx-table-border: var(--wx-border);
--wx-table-select-border: inset 3px 0 var(--wx-color-primary);
--wx-table-header-border: var(--wx-table-border);
--wx-table-header-cell-border: var(--wx-table-border);
--wx-table-footer-cell-border: var(--wx-table-border);
--wx-table-cell-border: var(--wx-table-border);
--wx-header-font-weight: 600;
--wx-table-header-background: #20262b;
--wx-table-fixed-column-right-border: 3px solid var(--wx-background-alt);
--wx-table-editor-dropdown-border: var(--wx-border);
--wx-table-editor-dropdown-shadow: 0px 4px 16px 0px rgba(0, 0, 0, 0.6);
}

.wx-willow-dark-theme .menu {
box-shadow: 0px 4px 16px 0px rgba(0, 0, 0, 0.6);
outline: var(--wx-border);
}

Applying a theme​

You can style the interface by applying one of the two themes:

  • Willow
  • WillowDark

Apply the desired theme by importing the theme from the source file and wrapping Grid into the required theme tag:

import { Grid, Willow } from "@svar-ui/react-grid";
import "@svar-ui/react-grid/all.css";

export default function Demo() {
return (
<Willow>
<Grid />
</Willow>
);
}

Customizing theme settings​

To change the table styles, create a CSS class by changing values of the required CSS variables and apply it to the Grid container.

The example below will change any current theme applied to the table.

Example:

import { getData } from "./common/data";
import { Grid } from "@svar-ui/react-grid";

export default function Demo() {
const { data, columns } = getData();

return (
<div className="demo" style={{ padding: 20 }}>
<div>
<Grid data={data} columns={columns} footer={true} />
</div>
</div>
);
}
.demo {
--wx-table-header-background: #2ca0e3;
--wx-border: 1px solid #818080;
--wx-table-header-cell-border: #2ca0e3;
}

The example below demonstrates how to change the Willow theme that is applied to the table:

import { getData } from "./common/data";
import { Grid, Willow } from "@svar-ui/react-grid";

export default function Demo() {
const { data, columns } = getData();

return (
<Willow>
<Grid data={data} columns={columns} footer={true} />
</Willow>
);
}
.wx-willow-theme {
--wx-table-header-background: #2ca0e3;
--wx-border: 1px solid #818080;
--wx-table-header-cell-border: #2ca0e3;
}

Disabling fonts​

Whenever you need to disable the fonts used in a theme, you can make use of the fonts property of the theme and set it to the false value:

import { getData } from "./common/data";
import { Grid, Willow } from "@svar-ui/react-grid";
import "@svar-ui/react-grid/all.css";

export default function Demo() {
return (
<div style={{ width: 300 }}>
<Willow fonts={false}>
<Grid />
</Willow>
</div>
);
}
Pay attention

Please note that if you switch the default fonts off, you will have to include the fonts you need by yourself.

Styling cells​

The widget allows applying a custom React component to a cell and styling a cell with a custom CSS class.

info

This section describes how to apply styles to cells. If you want to know how to apply custom components to cells, see the Applying custom components section.

To add a CSS class to a cell, use the cellStyle property. cellStyle can be defined as a function that returns the name of a CSS class or an empty string.

Example:

import { getData } from "./common/data";
import { Grid } from "@svar-ui/react-grid";
import "@svar-ui/react-grid/all.css";

export default function Demo() {
const { data, columns } = getData();

return (
<Grid
data={data}
columns={columns}
cellStyle={(row, col) => (row.id === 14 && col.id === 'lastName' ? 'cellStyle' : '')}
footer={true}
/>
);
}
.row:not(.selected) .cellStyle {
color: white;
background: #1b85dc;
}

Styling columns​

To add a CSS class to a column, define the columnStyle property. columnStyle can be a function that returns the name of a CSS class or an empty string.

Example:

import { getData } from "./common/data";
import { Grid } from "@svar-ui/react-grid";
import "@svar-ui/react-grid/all.css";

export default function Demo() {
const { data, columns } = getData();

return (
<div style={{ padding: 20 }}>
<div>
<Grid
data={data}
columns={columns}
columnStyle={col => (col.id === 'city' ? 'columnStyle' : '')}
footer={true}
/>
</div>
</div>
);
}
.columnStyle {
text-decoration: underline;
color: rgb(231, 7, 231);
}

Styling rows​

To add a css class to a row, define the rowStyle property. The property can be a function that returns the name of a CSS class or an empty string.

Example:

import { getData } from "./common/data";
import { Grid } from "@svar-ui/react-grid";

export default function Demo() {
const { data, columns } = getData();

return (
<Grid
data={data}
columns={columns}
rowStyle={row => (row.id === 11 ? 'rowStyle' : '')}
footer={true}
/>
);
}
.rowStyle:not(.selected) .cell {
color: white;
background: #0ebf6c;
}

Related sample: Styling

Related articles: